;-----------------------------------------------------------------------------
func load_levels ;////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
	mov	esi,file_levels
	mov	edi,finfo+20
	mov	ecx,file_levels.size
	rep	movsb
	mov	dword[finfo+12],levels
	mcall	58,finfo
	ret
endf

;-----------------------------------------------------------------------------
func load_graphics ;//////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
	mov	esi,file_resource
	mov	edi,finfo+20
	mov	ecx,file_resource.size
	rep	movsb
	mov	dword[finfo+12],@LDATA
	mcall	58,finfo
	add	ebx,@LDATA
;       mov     [res_start],ebx
	mov	ecx,[@LDATA+0x19]
	dec	ecx
	mov	esi,@LDATA+0x1D
	mov	edi,ebx
  .lp1: mov	ebp,[esi]
	add	ebp,@LDATA
	mov	eax,[ebp+18] ; width
	mov	[edi+2],ax
	mov	eax,[ebp+22] ; height
	mov	[edi],ax
	add	edi,4
	mov	[esi],edi
	push	ecx esi
	call	convert_image
	pop	esi ecx
	add	esi,28
	loop	.lp1
	mov	dword[GRAPH_BUFFER1-4],800*65536+600
	ret
endf

;-----------------------------------------------------------------------------
func pt_in_rect ;/////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
	cmp	ax,[ecx+0x00]
	jb	@f
	cmp	bx,[ecx+0x02]
	jb	@f
	cmp	ax,[ecx+0x04]
	ja	@f
	cmp	bx,[ecx+0x06]
	ja	@f
	stc
	ret
    @@: clc
	ret
endf

;-----------------------------------------------------------------------------
func button_from_point ;//////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
	mov	ecx,[cur_buttons]
	add	ecx,8
	xor	edx,edx
    @@: call	pt_in_rect
	jc	@f
	add	ecx,16
	inc	dl
	cmp	byte[ecx],0
	jne	@b
	or	dl,-1
    @@: or	dl,dl
	ret
endf

;-----------------------------------------------------------------------------
func define_buttons ;/////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
	push	ebp
	mov	edx,0x60000002
    @@: mov	ebx,[ebp+8-2]
	mov	bx,[ebp+8+4]
	sub	bx,[ebp+8]
	mov	ecx,[ebp+8+2-2]
	mov	cx,[ebp+8+2+4]
	sub	cx,[ebp+8+2]
	add	ecx,0x000A0000
	mcall	8,,,,0x007F7F7F

	push	ebp edx
	mov	esi,[ebp+4]
	mov	di,[ebp+8]
	shl	edi,16
	mov	di,[ebp+10]
	add	edi,0x00020002
	mov	ebp,font1
	call	draw_string
	pop	edx ebp

	inc	edx
	add	ebp,16
	cmp	byte[ebp],0
	jne	@b
	pop	ebp
	ret
endf