;-----------------------------------------------------------------------------
func move_snake ;/////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EBX = snake data pointer
;-----------------------------------------------------------------------------
	cmp	byte[ebx-11],0
	je	.exit.2
	push	eax
	inc	byte[ebx-2]
	cmp	byte[ebx-2],20
	jb	.exit.1
	mov	byte[ebx-2],0
	lea	esi,[ebx+101*2]
	lea	edi,[ebx+102*2]
	mov	ecx,102
	std
	rep	movsw
	cld
	cmp	byte[ebx-12],0
	je	@f
	inc	byte[ebx-1]
	dec	byte[ebx-12]
    @@:
	mov	cl,[ebx+DIR_START]
	cmp	byte[ebx+DIR_START+DIR_NUM],0
	je	@f
	dec	byte[ebx+DIR_START+DIR_NUM]
	jz	@f
	mov	ch,[ebx+DIR_START+1]
	mov	[ebx+DIR_START],ch
    @@: cmp	cl,0
	jne	@f
	dec	byte[ebx+0]
	jmp	.exit.0
    @@: cmp	cl,1
	jne	@f
	dec	byte[ebx+1]
	jmp	.exit.0
    @@: cmp	cl,2
	jne	@f
	inc	byte[ebx+0]
	jmp	.exit.0
    @@: cmp	cl,3
	jne	.exit.0
	inc	byte[ebx+1]
  .exit.0:
	mov	ax,[ebx+4]
	cmp	al,[ebx+0]
	je	.exit.1
	cmp	ah,[ebx+1]
	jne	@f
	jmp	.exit.1
    @@: movzx	eax,byte[ebx+1]
	imul	eax,40
	movzx	ecx,byte[ebx+0]
	cmp	byte[rnd_field+eax+ecx],3
	jb	.exit.1
	mov	ax,[ebx+2]
	mov	cx,[ebx+4]
	sub	cl,al
	jz	@f
	sub	al,cl
	and	cl,10b
	mov	[ebx+DIR_START],cl
    @@: sub	ch,ah
	jz	@f
	sub	ah,ch
	and	ch,11b
	mov	[ebx+DIR_START],ch
    @@: mov	[ebx+0],ax
  .exit.1:

	movzx	eax,byte[ebx+1]
	imul	eax,40
	movzx	ecx,byte[ebx+0]
	cmp	byte[rnd_field+eax+ecx],3
	jb	@f
	add	esp,4
	call	kill_snake
	jmp	.exit.2
    @@:

	mov	ax,[ebx]
	lea	edi,[ebx+2]
	movzx	ecx,byte[ebx-1]
	push	ecx
	repne	scasw
	jne	@f
	sub	cl,[ebx-1]
	neg	cl
	dec	cl
	mov	[ebx-1],cl
	mov	ecx,[esp]
	call	erase_snake_tail
    @@: pop	ecx

	push	ebx
	mov	ax,[ebx]
	mov	ebx,[ebx-8]
	lea	edi,[ebx+2]
	movzx	ecx,byte[ebx-1]
	push	ecx
	repne	scasw
	jne	@f
	sub	cl,[ebx-1]
	neg	cl
	dec	cl
	cmp	cl,3
	jge	.lp2
	or	cl,cl
	jnz	.lp1
	mov	ecx,[ebx-8]
	mov	cl,[ecx+DIR_START]
	xor	cl,10b
	cmp	cl,[ebx+DIR_START]
	jne	.lp1
	call	kill_snake
  .lp1: mov	ebx,[ebx-8]
	call	kill_snake
	jmp	@f
  .lp2: mov	[ebx-1],cl
	mov	ecx,[esp]
	call	erase_snake_tail
    @@: pop	ecx ebx

	mov	ax,[ebx]
	sub	ax,0x0101
	mov	edi,TELEPORTS_LIST
	movzx	ecx,byte[TELEPORTS_LIST-1]
	shl	ecx,1
	repne	scasw
	jne	@f
	lea	esi,[edi-2]
	test	ecx,1
	jnz	.lp3
	sub	edi,4
	sub	esi,4
  .lp3: mov	ax,[ebx+0]
	sub	ax,[ebx+2]
	add	ax,[edi]
	add	ax,0x0101
	mov	[ebx],ax
    @@:
	pop	eax
  .exit.2:
	ret
endf

;-----------------------------------------------------------------------------
func draw_snake ;/////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; ESI = snake data pointer
; EBP = snake skin (0 or 1)
;-----------------------------------------------------------------------------
	cmp	byte[esi-3],15
	jne	.draw_respawn
	movzx	eax,byte[esi-2]
	imul	eax,28
	imul	ebp,28*20
	mov	ebx,[@LDATA+0x1D+28*31+ebp+eax]
	movzx	ecx,byte[esi-1]
	push	esi

	call	get_skin_ofs
	cmp	byte[esi-2],0
	je	@f
	xor	eax,eax
	call	.draw_snake_unit
    @@: add	esi,2
	mov	eax,20
	call	.draw_snake_unit

	sub	ecx,3
	jz	.lp2
  .lp1: call	get_skin_ofs
	add	esi,2
	mov	eax,40
	call	.draw_snake_unit
	loop	.lp1
  .lp2:

	pop	eax
	cmp	byte[eax-12],0
	je	@f
	call	get_skin_ofs
	add	esi,2
	mov	eax,40
	call	.draw_snake_unit
	call	get_skin_ofs.2
	add	esi,2
	mov	eax,100
	call	.draw_snake_unit
	jmp	.lp3
    @@:
	call	get_skin_ofs
	add	esi,2
	mov	eax,60
	call	.draw_snake_unit
	add	esi,2
	mov	eax,80
	call	.draw_snake_unit
  .lp3:

	ret

  .draw_snake_unit:
	pushad

	push	esi
	mov	esi,ebx
	mov	edi,@LDATA+0x00010000
	mov	dword[edi-4],0x00140014
	mov	ebx,eax
	mov	eax,ebp
	call	getimg

	mov	esi,[esp]

	movzx	eax,byte[esi+0]
	imul	eax,20
	movzx	ebx,byte[esi+1]
	imul	ebx,20
	add	ebx,20
	mov	esi,GRAPH_BUFFER1
	mov	edi,@LDATA+0x00010500
	mov	dword[edi-4],0x00140014
	call	getimg

	mov	esi,@LDATA+0x00010000
	mov	ecx,20*20
	call	transp_combine

	pop	esi

	movzx	eax,byte[esi+0]
	imul	eax,20
	shl	eax,16
	movzx	edx,byte[esi+1]
	imul	edx,20
	add	eax,20
	add	edx,eax
	mcall	7,@LDATA+0x00010500,<20,20>
	popad
	ret

  .draw_respawn:
	movzx	eax,byte[esi-4]
	imul	eax,20
	movzx	ebx,byte[esi-3]
	imul	ebx,45
	inc	byte[esi-3]

	push	esi
	mov	esi,[@LDATA+0x1D+28*71]
	mov	edi,@LDATA+0x00010000
	mov	dword[edi-4],0x0014002D
	call	getimg
	pop	esi

	mov	ebx,20*29
	cmp	byte[esi-4],0
	je	@f
	mov	ebx,20*10
    @@:
	mov	ecx,20*24+20
	call	transp_blt

	ret
endf

;-----------------------------------------------------------------------------
func erase_snake_tail ;///////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EBX = snake data pointer
; ECX = old snake length
;-----------------------------------------------------------------------------
	push	ebx
	movzx	eax,byte[ebx-1]
	sub	ecx,eax
	inc	ecx
	lea	esi,[ebx+eax*2]
  .lp1: push	ecx esi

	movzx	eax,byte[esi+0]
	imul	eax,20
	movzx	ebx,byte[esi+1]
	imul	ebx,20
	add	ebx,20
	mov	esi,GRAPH_BUFFER1
	mov	edi,@LDATA+0x00010500
	mov	dword[edi-4],0x00140014
	call	getimg

	mov	esi,[esp]

	movzx	eax,byte[esi+0]
	imul	eax,20
	shl	eax,16
	movzx	edx,byte[esi+1]
	imul	edx,20
	add	eax,20
	add	edx,eax
	mcall	7,@LDATA+0x00010500,<20,20>

	pop	esi ecx
	add	esi,2
	loop	.lp1
	pop	ebx
	ret
endf

;-----------------------------------------------------------------------------
func kill_snake ;/////////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; EBX = snake data pointer
;-----------------------------------------------------------------------------
	movzx	ecx,byte[ebx-1]
	mov	byte[ebx-1],0
	call	erase_snake_tail
	mov	byte[ebx-1],3
	mov	ax,[ebx-10]
	mov	[ebx],ax
	inc	ah
	mov	[ebx+2],ax
	inc	ah
	mov	[ebx+4],ax
	inc	ah
	mov	[ebx+6],ax
	mov	byte[ebx+DIR_START+DIR_NUM],0
	mov	byte[ebx+DIR_START],01b
	mov	byte[ebx-2],0
	mov	byte[ebx-3],0
	mov	byte[ebx-11],0
	ret
endf

;-----------------------------------------------------------------------------
func get_skin_ofs ;///////////////////////////////////////////////////////////
;-----------------------------------------------------------------------------
; ESI = pointer to snake unit coordinates
;-----------------------------------------------------------------------------
	xor	edx,edx
	mov	al,[esi+2] ; 2nd x
	sub	al,[esi+0] ; 1st x
	call	.check_x
	jns	@f
	or	dl,00100000b
	jmp	.ok1
    @@: jnz	.ok1
	mov	al,[esi+3] ; 2nd y
	sub	al,[esi+1] ; 1st y
	call	.check_y
	jns	@f
	or	dl,00110000b
	jmp	.ok1
    @@: jz	.ok1
	or	dl,00010000b
  .ok1:
	mov	al,[esi+2] ; 2nd x
	sub	al,[esi+4] ; 3rd x
	call	.check_x
	jns	@f
	or	dl,00001000b
	jmp	.ok2
    @@: jnz	.ok2
	mov	al,[esi+3] ; 2nd y
	sub	al,[esi+5] ; 3rd y
	call	.check_y
	jns	@f
	or	dl,00001100b
	jmp	.ok2
    @@: jz	.ok2
	or	dl,00000100b
  .ok2:
	mov	ebp,[skin_ofs+edx]
	ret

  .2:	xor	edx,edx
	mov	al,[esi+3] ; 2nd x
	sub	al,[esi+1] ; 1st x
	call	.check_y
	jns	@f
	or	dl,00000001b
	jmp	.2.ok
    @@: jnz	.2.ok
	mov	al,[esi+2] ; 2nd y
	sub	al,[esi+0] ; 1st y
	call	.check_x
	jns	@f
	or	dl,00000011b
	jmp	.2.ok
    @@: jz	.2.ok
	or	dl,00000010b
  .2.ok:
	imul	ebp,edx,20
	ret

  .check_x:
	cmp	al,-1
	jl	.lp1
	cmp	al,1
	jle	.lp2
  .lp1: call	.find_teleport
	sub	al,[esi+2] ; 2nd x
	neg	al
  .lp2: or	al,al
	ret

  .check_y:
	cmp	al,-1
	jl	.lp3
	cmp	al,1
	jle	.lp4
  .lp3: call	.find_teleport
	mov	al,[esi+3] ; 2nd y
	sub	al,ah
  .lp4: or	al,al
	ret

  .find_teleport: ; result in ax
	push	ecx
	mov	edi,TELEPORTS_LIST
	movzx	ecx,byte[edi-1]
	shl	ecx,1
	mov	ax,[esi+2]
	sub	ax,0x0101
	push	edi ecx eax
	sub	ax,0x0101
	repne	scasw
	je	.found_teleport
	mov	edi,[esp+8]
	mov	ecx,[esp+4]
	mov	eax,[esp]
	dec	ah
	repne	scasw
	je	.found_teleport
	mov	edi,[esp+8]
	mov	ecx,[esp+4]
	mov	eax,[esp]
	dec	ah
	inc	al
	repne	scasw
	je	.found_teleport
	mov	edi,[esp+8]
	mov	ecx,[esp+4]
	mov	eax,[esp]
	dec	al
	repne	scasw
	je	.found_teleport
	mov	edi,[esp+8]
	mov	ecx,[esp+4]
	mov	eax,[esp]
	inc	al
	repne	scasw
	je	.found_teleport
	mov	edi,[esp+8]
	mov	ecx,[esp+4]
	mov	eax,[esp]
	inc	ah
	dec	al
	repne	scasw
	je	.found_teleport
	mov	edi,[esp+8]
	mov	ecx,[esp+4]
	mov	eax,[esp]
	inc	ah
	repne	scasw
	je	.found_teleport
	mov	edi,[esp+8]
	mov	ecx,[esp+4]
	mov	eax,[esp]
	add	ax,0x0101
	repne	scasw
;       je      .found_teleport
  .found_teleport:
	mov	ax,[edi-2]
	add	ax,0x0101
	add	esp,4*3
	pop	ecx
	ret
endf